package org.owasp.csrfguard.http;

import java.io.DataOutputStream;
import java.io.IOException;
import java.io.OutputStream;

import javax.servlet.ServletOutputStream;

public final class FilterOutputStream extends ServletOutputStream
{
    private DataOutputStream stream = null;
    
    public FilterOutputStream(OutputStream output)
    {
        stream = new DataOutputStream(output);
    }
    
    public void write(int b) throws IOException
    {
        stream.write(b);
    }
    
    public void write(byte[] b) throws IOException
    {
        stream.write(b);
    }
    
    public void write(byte[] b, int off, int len) throws IOException
    {
        stream.write(b, off, len);
    }
    
    public void flush() throws IOException
    {
        stream.flush();
    }
}