package org.owasp.csrfguard.util;

import java.net.URLEncoder;
import java.io.UnsupportedEncodingException;
import java.security.SecureRandom;
import java.security.NoSuchAlgorithmException;
import sun.misc.BASE64Encoder;

public final class CryptoUtil
{
	public final static String DEFAULT_PRNG = "SHA1PRNG";
	
	private static BASE64Encoder b64Encoder = new BASE64Encoder();
	
	public static String generateRandomToken(int length) throws NoSuchAlgorithmException
	{
		return generateRandomToken(DEFAULT_PRNG, length);
	}
	
	public static String generateRandomToken(String algo, int length) throws NoSuchAlgorithmException
	{
		SecureRandom sr = SecureRandom.getInstance(algo);
		byte[] bytes = new byte[length];
		
		sr.nextBytes(bytes);
		return BASE64Encode(bytes);
	}
	
	public static synchronized String BASE64Encode(byte[] bytes)
	{
		return b64Encoder.encode(bytes);
	}
	
	public static String URLEncode(String s) throws UnsupportedEncodingException
	{
		return (s == null ? null : URLEncoder.encode(s, "UTF8"));
	}
}
